Index: /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py	(revision 65805)
+++ /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py	(revision 65806)
@@ -49,21 +49,21 @@
 # Annotation example:
 #
-# @opmnemonic  add
-# @op1         reg:Eb
-# @op2         rm:Gb
-# @opmaps      onebyte
-# @oppfx       none
-# @opcode      0x00
-# @openc       ModR/M
-# @opfltest    none
-# @opflmodify  of,sz,zf,af,pf,cf
-# @opflundef   none
-# @opflset     none
-# @opflclear   none
-# @ophints     harmless
-# @opstats     add_Eb_Gb
-# @opgroup     op_gen_arith_bin
-# @optest                  in1=1 in2=1 -> out1=2 outfl=a?,p?
-# @optest      oppfx:o32   in1=0xfffffffe:dw in2=1:dw -> out1=0xffffffff:dw outfl=a?,p?
+# \@opmnemonic  add
+# \@op1         reg:Eb
+# \@op2         rm:Gb
+# \@opmaps      onebyte
+# \@oppfx       none
+# \@opcode      0x00
+# \@openc       ModR/M
+# \@opfltest    none
+# \@opflmodify  of,sz,zf,af,pf,cf
+# \@opflundef   none
+# \@opflset     none
+# \@opflclear   none
+# \@ophints     harmless
+# \@opstats     add_Eb_Gb
+# \@opgroup     op_gen_arith_bin
+# \@optest                  in1=1 in2=1 -> out1=2 outfl=a?,p?
+# \@optest      oppfx:o32   in1=0xfffffffe:dw in2=1:dw -> out1=0xffffffff:dw outfl=a?,p?
 
 
@@ -149,8 +149,8 @@
     ## CPU context fields.
     kdFields = {
-        'op1': [],  ## @op1
-        'op2': [],  ## @op2
-        'op3': [],  ## @op3
-        'op4': [],  ## @op4
+        'op1': [],  ## \@op1
+        'op2': [],  ## \@op2
+        'op3': [],  ## \@op3
+        'op4': [],  ## \@op4
 
         'efl': [],
@@ -283,5 +283,5 @@
     """
 
-    ## @op[1-4]
+    ## \@op[1-4]
     kdLocations = {
         'reg':  [], ## modrm.reg
@@ -289,5 +289,5 @@
     };
 
-    ## @op[1-4]
+    ## \@op[1-4]
     kdTypes = {
         'Eb':   [],
@@ -686,5 +686,5 @@
     def parseTagOpBrief(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Key:    @opbrief
+        Tag:    \@opbrief
         Value:  Text description, multiple sections, appended.
 
@@ -716,5 +716,5 @@
     def parseTagOpDesc(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Key:    @opdesc
+        Tag:    \@opdesc
         Value:  Text description, multiple sections, appended.
 
@@ -754,5 +754,5 @@
     def parseTagOpOperandN(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tags:  @op1, @op2, @op3, @op4
+        Tags:  \@op1, \@op2, \@op3, \@op4
         Value: where:type
 
@@ -799,5 +799,5 @@
     def parseTagOpMaps(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:    @opmaps
+        Tag:    \@opmaps
         Value:  map[,map2]
 
@@ -832,5 +832,5 @@
         return True;
 
-    ## @oppfx values.
+    ## \@oppfx values.
     kdPrefixes = {
         '0x66': [],
@@ -841,5 +841,5 @@
     def parseTagOpPfx(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @oppfx
+        Tag:        \@oppfx
         Value:      none|0x66|0xf3|0xf2
 
@@ -875,5 +875,5 @@
         return True;
 
-    ## Special @opcode tag values.
+    ## Special \@opcode tag values.
     kdSpecialOpcodes = {
         '/reg':         [],
@@ -887,5 +887,5 @@
     def parseTagOpcode(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @opcode
+        Tag:        \@opcode
         Value:      0x?? | /reg | mr/reg | 11 /reg | !11 /reg | 11 mr/reg | !11 mr/reg
 
@@ -909,5 +909,5 @@
         return True;
 
-    ## Valid values for @openc
+    ## Valid values for \@openc
     kdEncodings = {
         'ModR/M': [],
@@ -916,5 +916,5 @@
     def parseTagOpEnc(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @openc
+        Tag:        \@openc
         Value:      ModR/M|TBD
 
@@ -939,5 +939,5 @@
         return True;
 
-    ## EFlags values allowed in @opfltest, @opflmodify, @opflundef, @opflset, and @opflclear.
+    ## EFlags values allowed in \@opfltest, \@opflmodify, \@opflundef, \@opflset, and \@opflclear.
     kdEFlags = {
         # Debugger flag notation:
@@ -996,5 +996,9 @@
 
     def parseTagOpEFlags(self, sTag, aasSections, iTagLine, iEndLine):
-        """ @opfltest, @opflmodify, @opflundef, @opflset, @opflclear """
+        """
+        Tags:   \@opfltest, \@opflmodify, \@opflundef, \@opflset, \@opflclear
+        Value:  <eflags specifier>
+
+        """
         oInstr = self.ensureInstructionForOpTag(iTagLine);
 
@@ -1023,5 +1027,5 @@
         return True;
 
-    ## @ophints values.
+    ## \@ophints values.
     kdHints = {
         'invalid':               'DISOPTYPE_INVALID',                ##<
@@ -1057,5 +1061,5 @@
     def parseTagOpHints(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @ophints
+        Tag:        \@ophints
         Value:      Comma or space separated list of flags and hints.
 
@@ -1089,5 +1093,5 @@
         return True;
 
-    ## @opcpuid
+    ## \@opcpuid
     kdCpuIdFlags =  {
         'vme':      'X86_CPUID_FEATURE_EDX_VME',
@@ -1135,5 +1139,5 @@
     def parseTagOpCpuId(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @opcpuid
+        Tag:        \@opcpuid
         Value:      none | <CPUID flag specifier>
 
@@ -1169,5 +1173,5 @@
     def parseTagOpGroup(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @opgroup
+        Tag:        \@opgroup
         Value:      op_grp1[_subgrp2[_subsubgrp3]]
 
@@ -1193,5 +1197,5 @@
         return True;
 
-    ## @opunused, @opinvalid, @opinvlstyle
+    ## \@opunused, \@opinvalid, \@opinvlstyle
     kdInvalidStyles = {
         'immediate':                [], ##< CPU stops decoding immediately after the opcode.
@@ -1204,15 +1208,15 @@
     def parseTagOpUnusedInvalid(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:    @opunused, @opinvalid, @opinvlstyle
+        Tag:    \@opunused, \@opinvalid, \@opinvlstyle
         Value:  <invalid opcode behaviour style>
 
-        The @opunused indicates the specification is for a currently unused
+        The \@opunused indicates the specification is for a currently unused
         instruction encoding.
 
-        The @opinvalid indicates the specification is for an invalid currently
+        The \@opinvalid indicates the specification is for an invalid currently
         instruction encoding (like UD2).
 
-        The @opinvlstyle just indicates how CPUs decode the instruction when
-        not supported (@opcpuid, @opmincpu) or disabled.
+        The \@opinvlstyle just indicates how CPUs decode the instruction when
+        not supported (\@opcpuid, \@opmincpu) or disabled.
         """
         oInstr = self.ensureInstructionForOpTag(iTagLine);
@@ -1250,5 +1254,5 @@
     def parseTagOpTest(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @optest
+        Tag:        \@optest
         Value:      [<selectors>[ ]?] <inputs> -> <outputs>
         Example:    mode==64bit ? in1=0xfffffffe:dw in2=1:dw -> out1=0xffffffff:dw outfl=a?,p?
@@ -1380,5 +1384,5 @@
     def parseTagOpFunction(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @opfunction
+        Tag:        \@opfunction
         Value:      <VMM function name>
 
@@ -1408,5 +1412,5 @@
     def parseTagOpStats(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:        @opstats
+        Tag:        \@opstats
         Value:      <VMM statistics base name>
 
@@ -1436,5 +1440,5 @@
     def parseTagOpDone(self, sTag, aasSections, iTagLine, iEndLine):
         """
-        Tag:    @opdone
+        Tag:    \@opdone
         Value:  none
 