Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py	(revision 65959)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py	(revision 65962)
@@ -500,5 +500,5 @@
         Raises BadValue if invalid value.
         """
-        if len(sValue) == 0:
+        if not sValue:
             raise TestType.BadValue('empty value');
 
@@ -1149,5 +1149,5 @@
         Returns number of errors.
         """
-        if len(self.asErrors) > 0:
+        if self.asErrors:
             sys.stderr.write(u''.join(self.asErrors));
         return len(self.asErrors);
@@ -1177,5 +1177,5 @@
             asWords = sStats.split('_');
             oInstr.sMnemonic = asWords[0].lower();
-            if len(asWords) > 1 and len(oInstr.aoOperands) == 0:
+            if len(asWords) > 1 and not oInstr.aoOperands:
                 for sType in asWords[1:]:
                     if sType in g_kdOpTypes:
@@ -1248,5 +1248,5 @@
         # Derive encoding from operands.
         if oInstr.sEncoding is None:
-            if len(oInstr.aoOperands) == 0:
+            if not oInstr.aoOperands:
                 oInstr.sEncoding = 'fixed';
             elif oInstr.aoOperands[0].usesModRM():
@@ -1259,5 +1259,5 @@
         # Apply default map and then add the instruction to all it's groups.
         #
-        if len(oInstr.aoMaps) == 0:
+        if not oInstr.aoMaps:
             oInstr.aoMaps = [ self.oDefaultMap, ];
         for oMap in oInstr.aoMaps:
@@ -1324,5 +1324,5 @@
     def ensureInstructionForOpTag(self, iTagLine):
         """ Ensure there is an instruction for the op-tag being parsed. """
-        if len(self.aoCurInstrs) == 0:
+        if not self.aoCurInstrs:
             self.addInstruction(self.iCommentLine + iTagLine);
         for oInstr in self.aoCurInstrs:
@@ -1340,5 +1340,5 @@
         asRet = [];
         for asLines in aasSections:
-            if len(asLines) > 0:
+            if asLines:
                 asRet.append(' '.join([sLine.strip() for sLine in asLines]));
         return asRet;
@@ -1356,5 +1356,5 @@
         sRet = '';
         for iSection, asLines in enumerate(aasSections):
-            if len(asLines) > 0:
+            if asLines:
                 if iSection > 0:
                     sRet += sSectionSep;
@@ -1378,5 +1378,5 @@
         # Flatten and validate the value.
         sBrief = self.flattenAllSections(aasSections);
-        if len(sBrief) == 0:
+        if not sBrief:
             return self.errorComment(iTagLine, '%s: value required' % (sTag,));
         if sBrief[-1] != '.':
@@ -1405,5 +1405,5 @@
         """
         oInstr = self.ensureInstructionForOpTag(iTagLine);
-        if len(aasSections) > 0:
+        if aasSections:
             oInstr.asDescSections.extend(self.flattenSections(aasSections));
             return True;
@@ -1498,5 +1498,5 @@
         sFlattened = self.flattenAllSections(aasSections, sLineSep = ',', sSectionSep = ',');
         asMaps = sFlattened.split(',');
-        if len(asMaps) == 0:
+        if not asMaps:
             return self.errorComment(iTagLine, '%s: value required' % (sTag,));
         for sMap in asMaps:
@@ -1742,5 +1742,5 @@
         if len(asWords) != 1:
             self.errorComment(iTagLine, '%s: expected exactly one value: %s' % (sTag, asWords,));
-            if len(asWords) == 0:
+            if not asWords:
                 return False;
         sDisEnum = asWords[0];
@@ -1911,5 +1911,5 @@
             #
             sFlatSection = self.flattenAllSections([asSectionLines,]);
-            if len(sFlatSection) == 0:
+            if not sFlatSection:
                 self.errorComment(iTagLine, '%s: missing value' % ( sTag,));
                 continue;
@@ -2118,9 +2118,9 @@
             asLines[iLine] = sLine.lstrip().lstrip('*').lstrip();
 
-        while len(asLines) > 0 and len(asLines[0]) == 0:
+        while asLines and not asLines[0]:
             self.iCommentLine += 1;
             asLines.pop(0);
 
-        while len(asLines) > 0 and len(asLines[-1]) == 0:
+        while asLines and not asLines[-1]:
             asLines.pop(len(asLines) - 1);
 
@@ -2142,7 +2142,7 @@
         for iLine, sLine in enumerate(asLines):
             if not sLine.startswith('@'):
-                if len(sLine) > 0:
+                if sLine:
                     asCurSection.append(sLine);
-                elif len(asCurSection) != 0:
+                elif asCurSection:
                     asCurSection = [];
                     aasSections.append(asCurSection);
@@ -2189,5 +2189,5 @@
         # Don't allow default text in blocks containing @op*.
         #
-        if cOpTags > 0 and len(sFlatDefault) > 0:
+        if cOpTags > 0 and sFlatDefault:
             self.errorComment(0, 'Untagged comment text is not allowed with @op*: %s' % (sFlatDefault,));
 
@@ -2287,5 +2287,5 @@
 
         # Apply to the last instruction only for now.
-        if len(self.aoCurInstrs) == 0:
+        if not self.aoCurInstrs:
             self.addInstruction();
         oInstr = self.aoCurInstrs[-1];
@@ -2404,5 +2404,5 @@
                 sFunction = asArgs[1];
 
-                if len(self.aoCurInstrs) == 0:
+                if not self.aoCurInstrs:
                     self.addInstruction();
                 for oInstr in self.aoCurInstrs: