Index: /trunk/include/VBox/err.mac
===================================================================
--- /trunk/include/VBox/err.mac	(revision 66147)
+++ /trunk/include/VBox/err.mac	(revision 66148)
@@ -180,4 +180,5 @@
 %define VERR_PGM_INVALID_LARGE_PAGE_RANGE    (-1645)
 %define VERR_PGM_PHYS_PAGE_BALLOONED    (-1646)
+%define VERR_PGM_HANDLER_IPE_1    (-1647)
 %define VERR_PGM_MAP_MMIO2_ALIAS_MMIO    (-1651)
 %define VERR_PGM_MAPPINGS_DISABLED    (-1652)
@@ -214,4 +215,5 @@
 %define VERR_PGM_TOO_MANY_MMIO2_RANGES    (-1683)
 %define VERR_PGM_PHYS_PAGE_MAP_MMIO2_IPE    (-1684)
+%define VERR_PGM_PHYS_MMIO_EX_IPE    (-1685)
 %define VERR_MM_RAM_CONFLICT    (-1700)
 %define VERR_MM_HYPER_NO_MEMORY    (-1701)
@@ -628,4 +630,5 @@
 %define VERR_VGA_INVALID_CUSTOM_MODE    (-3500)
 %define VINF_VGA_RESIZE_IN_PROGRESS    (3501)
+%define VERR_VGA_UNEXPECTED_PCI_REGION_LOAD_CHANGE    (-3502)
 %define VERR_INTNET_FLT_IF_NOT_FOUND    (-3600)
 %define VERR_INTNET_FLT_IF_BUSY    (-3601)
@@ -1028,4 +1031,5 @@
 %define VERR_AUDIO_NO_FREE_OUTPUT_STREAMS    (-6602)
 %define VERR_AUDIO_STREAM_PENDING_DISABLE    (-6603)
+%define VINF_AUDIO_MORE_DATA_AVAILABLE    (6604)
 %define VERR_APIC_INTR_NOT_PENDING    (-6700)
 %define VERR_APIC_INTR_MASKED_BY_TPR    (-6701)
Index: /trunk/include/VBox/param.mac
===================================================================
--- /trunk/include/VBox/param.mac	(revision 66147)
+++ /trunk/include/VBox/param.mac	(revision 66148)
@@ -1,5 +1,9 @@
 %ifndef ___VBox_param_h
 %define ___VBox_param_h
-%define VBOX_MAX_ALLOC_PAGE_COUNT   (256U * _1M / PAGE_SIZE)
+%if ARCH_BITS == 64
+ %define VBOX_MAX_ALLOC_PAGE_COUNT   (_512M / PAGE_SIZE)
+%else
+ %define VBOX_MAX_ALLOC_PAGE_COUNT   (_256M / PAGE_SIZE)
+%endif
 %define MM_HYPER_AREA_ADDRESS       0xa0000000
 %define MM_HYPER_AREA_MAX_SIZE      (40U * _1M)
@@ -18,4 +22,10 @@
 %endif
 %define MM_RAM_HOLE_SIZE_DEFAULT    (512U * _1M)
+%if HC_ARCH_BITS == 64
+ %define MM_MMIO_64_MAX             _1T
+%else
+ %define MM_MMIO_64_MAX             (_1G64 * 16)
+%endif
+%define MM_MMIO_32_MAX              _2G
 %define PGM_HANDY_PAGES             128
 %define PGM_HANDY_PAGES_SET_FF      32
Index: /trunk/include/iprt/err.mac
===================================================================
--- /trunk/include/iprt/err.mac	(revision 66147)
+++ /trunk/include/iprt/err.mac	(revision 66148)
@@ -135,4 +135,5 @@
 %define VERR_PROC_APT_PRIV_NOT_HELD    (-22412)
 %define VERR_PROC_IQ_PRIV_NOT_HELD    (-22413)
+%define VERR_MP_TOO_MANY_CPUS    (-22414)
 %define VERR_FILE_IO_ERROR    (-100)
 %define VERR_OPEN_FAILED    (-101)
@@ -619,4 +620,5 @@
 %define VERR_ASN1_INVALID_DATA_POINTER    (-22854)
 %define VERR_ASN1_TOO_DEEPLY_NESTED    (-22855)
+%define VERR_ASN1_UNEXPECTED_OBJ_ID    (-22856)
 %define VERR_ASN1_INTERNAL_ERROR_1    (-22895)
 %define VERR_ASN1_INTERNAL_ERROR_2    (-22896)
Index: /trunk/include/iprt/x86.mac
===================================================================
--- /trunk/include/iprt/x86.mac	(revision 66147)
+++ /trunk/include/iprt/x86.mac	(revision 66148)
@@ -438,4 +438,8 @@
 %define MSR_IA32_VMX_PROCBASED_CTLS2        0x48B
 %define MSR_IA32_VMX_EPT_VPID_CAP           0x48C
+%define MSR_IA32_VMX_TRUE_PINBASED_CTLS     0x48D
+%define MSR_IA32_VMX_TRUE_PROCBASED_CTLS    0x48E
+%define MSR_IA32_VMX_TRUE_EXIT_CTLS         0x48F
+%define MSR_IA32_VMX_TRUE_ENTRY_CTLS        0x490
 %define MSR_IA32_DS_AREA                    0x600
 %define MSR_RAPL_POWER_UNIT                 0x606
@@ -493,4 +497,5 @@
 %define  MSR_K6_EFER_LMA                     RT_BIT_32(10)
 %define  MSR_K6_EFER_NXE                     RT_BIT_32(11)
+%define  MSR_K6_EFER_BIT_NXE                 11
 %define  MSR_K6_EFER_SVME                    RT_BIT_32(12)
 %define  MSR_K6_EFER_LMSLE                   RT_BIT_32(13)
@@ -532,4 +537,8 @@
 %define MSR_K8_INT_PENDING                  0xc0010055
 %define MSR_K8_VM_CR                        0xc0010114
+%define MSR_K8_VM_CR_DPD                    RT_BIT_32(0)
+%define MSR_K8_VM_CR_R_INIT                 RT_BIT_32(1)
+%define MSR_K8_VM_CR_DIS_A20M               RT_BIT_32(2)
+%define MSR_K8_VM_CR_LOCK                   RT_BIT_32(3)
 %define MSR_K8_VM_CR_SVM_DISABLE            RT_BIT_32(4)
 %define MSR_K8_IGNNE                        0xc0010115
@@ -571,4 +580,5 @@
 %define X86_PTE_BIT_PAT                     7
 %define X86_PTE_BIT_G                       8
+%define X86_PTE_PAE_BIT_NX                  63
 %define X86_PTE_P                           RT_BIT_32(0)
 %define X86_PTE_RW                          RT_BIT_32(1)
@@ -971,4 +981,5 @@
 %define X86_MODRM_MOD_SHIFT     6
 %ifndef VBOX_FOR_DTRACE_LIB
+ %define X86_MODRM_MAKE(a_Mod, a_Reg, a_RegMem) (((a_Mod) << X86_MODRM_MOD_SHIFT) | ((a_Reg) << X86_MODRM_REG_SHIFT) | (a_RegMem))
 %endif
 %define X86_SIB_BASE_MASK     0x07
@@ -1013,6 +1024,6 @@
 %define X86_OP_PRF_SIZE_ADDR    0x67
 %define X86_OP_PRF_LOCK         0xf0
+%define X86_OP_PRF_REPZ         0xf3
 %define X86_OP_PRF_REPNZ        0xf2
-%define X86_OP_PRF_REPZ         0xf3
 %define X86_OP_REX_B            0x41
 %define X86_OP_REX_X            0x42